<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>ReadSpeaker Demo Page</title>
  <meta http-equiv="content-type"  content="text/html;charset=utf-8" />
  <script type="text/javascript" src="js/rs_embhl.js"></script>
</head>
<body>
<?php
function getAddress($type)
{
  $protocol = $_SERVER['HTTPS'] == 'on' ? 'https' : 'http';
	if ($type=="full")
	{
    return $protocol . '://' . $_SERVER['SERVER_NAME'] . htmlspecialchars($_SERVER['REQUEST_URI']);
	}
	else
	{
    return $protocol . '://' . $_SERVER['SERVER_NAME'] . '/';
	}
}
?>

<div id="content">

<div id="readspeaker_button1" class="rs_skip">
<a href="http://app.readspeaker.com/cgi-bin/rsent?customerid=5204&amp;lang=en_us&amp;speed=140&amp;readid=sub-content-1&amp;url=<?php echo getAddress('full'); ?>&amp;audiofilename=ReadSpeaker-Speech-Enables-OSU-Web-Pages" target="_blank" onclick="readpage(this.href, 'expanding-player-1'); return false;">
<img 
  style="border-style: none" 
  src="img/listen-en-us-icon.gif" 
  alt="Listen to this page" 
  title="Listen to this page" /></a>
</div>
<div id='expanding-player-1'></div> 

<div id="sub-content-1">

<h1 style="margin-top: 0">Using ReadSpeaker to Speech-Enable OSU Web Pages</h1>

<p>
<a href="http://www.voice-corp.com/text-to-speech-services-for-speech-enabling-the-web/ReadSpeaker-Enterprise/">VoiceCorp ReadSpeaker Enterprise</a> is a product that speech-enables web pages. If you click the &#8220;Listen&#8221; link at the top of this page you can see it in action.
</p>

<p>
To deploy ReadSpeaker, a web developer includes some JavaScript and standard HTML, including a link, in a web page. When the link is clicked, a small area expands to provide playback controls, and the page is read aloud in a high-quality synthetic voice. Text is highlighted as it is read. The user can either follow along as the page is read or she can download an MP3 of the page contents.
</p>

<p>
Ohio State University has purchased a license to ReadSpeaker for use on web pages within OSU and its sub-domains. The license period lasts through March 2011. During this time, web developers at OSU are encouraged to include the Listen link in their web pages. 
</p>

<p>
At the request of the Office of the CIO, a Steering Committee has formed to help oversee this year-long pilot deployment. During the pilot, the Steering Committee will be tracking deployment and usage of ReadSpeaker and issuing surveys to attempt to judge student, staff, and faculty satisfaction with the product. Continuing centralized support of ReadSpeaker is conditional on the success of the pilot. In the event that centralized support is discontinued after March 2011, your unit can independently negotiate a contract for your domain. 
</p>

<h2>Where Can I Use ReadSpeaker?</h2>
<p>
Developers at OSU can implement ReadSpeaker on any HTML web page at OSU so long as:
</p>
<ul>
  <li>the base URL ends in <code>osu.edu</code> or <code>ohio-state.edu</code></li>
  <li>the page is served via HTTP</li>
</ul>

<p>Our current license does not extend to secure (HTTPS) web pages. The Steering Committee may explore licensing for secure sites.</p>

<h2>Benefits and Uses of ReadSpeaker</h2>

<p>
Though ReadSpeaker can enhance the accessibility of web pages, it is important to stress that ReadSpeaker is <strong>not an alternative to coding web pages with accessibility in mind</strong>, using standards-based web development practices. ReadSpeaker is <strong>not a blindness product</strong>. Severely visually impaired users will continue to access your pages using screen readers that are installed on their own computers. ReadSpeaker does not interfere with screen reader performance.
</p>

<p>
Nevertheless, ReadSpeaker:
</p>

<ul>
	<li>Helps comprehension for students, staff, faculty, and visitors with any sort of reading disability (e.g., dyslexia).</li>
  <li>Provides an extra &#8220;learning modality&#8221; for	students with various cognitive disabilities (ADHD, etc.).</li>
	<li>May help students, staff, faculty, and visitors with mild to moderate vision disabilities.</li>
	<li>Assists language acquisition for non-native speakers of English.</li>
	<li>Can be used by all students to review publicly served content or as a general study aid.</li>
	<li>Helps build overall awareness of disability access and usability.</li>
</ul>

<h2>User Features</h2>

<p>
ReadSpeaker has features that will enhance the usability of web pages for many users:
</p>

<ul>
  <li>Under &#8220;Settings,&#8221; a user can enable or disable the highlighting of text and choose whether ReadSpeaker highlights individual words or only sentences.</li>
	<li>Under &#8220;Settings,&#8221; a user can set ReadSpeaker to read very slowly, at a normal speed, or quickly.</li>
	<li>If a user selects a portion of text with the mouse, she will get a pop-up Listen button which when clicked will read aloud only the selected text. And, if she wants, she can then click the download button on the ReadSpeaker control area to download an MP3 of only the portion of text she selected.</li>
</ul>

<h2>Browser Support</h2>

<p>
Listen link will work in all modern browsers that support Flash and JavaScript. Browsers that do not support Flash, such as iPhone's Safari and (currently) Android Chrome,  will not be able to play back pages with the highlighting effect. However, clicking the Listen link in these browsers will display a link to download an MP3 of the page.
</p>

<h2>Technical Support</h2>

<p>
As part of our contract with VoiceCorp, OSU developers are offered email and phone technical support. 
</p>

<ul>
  <li>Email Support: <a href="mailto:support@voice-corp.com">support@voice-corp.com</a>. In your email, include our customer ID number (5204) and the URL of the page you have questions about.</li> 
	<li>Phone Support: +46 18 60 44 41. Note that international charges apply.</li>
</ul>

<h2>Implementing ReadSpeaker Listen Link on Your Web Site</h2>

<p>
Below are in-page and downloadable code examples, information on <abbr title="Content Management System">CMS</abbr> plug-ins, recommendations on placement of the ReadSpeaker Listen link, controlling what gets read, setting the read rate, and including links for reading of PDF files. The section ends with a discussion of known issues users and developers may confront. 
</p>

<p>
If you want to test ReadSpeaker on your own site quickly, you can download all of the <a href="media/readspeaker-sample-code.zip">code and associated files for this page</a>. The files assume you are using PHP on your web server but should be easy to modify for any environment.
</p>

<h3>Including the ReadSpeaker Listen Link</h3>

<p>
Download the <a href="media/rs_embhl.js.txt">ReadSpeaker JavaScript file</a> and link to it in the head of your web page:
</p>

<pre class="rs_skip"><code>
&lt;script type=&quot;text/javascript&quot; src=&quot;js/rs_embhl.js&quot;&gt;&lt;/script&gt;

</code></pre>

<p>
Then include the Listen link. Below is a block that shows the code for including the Listen link in a web page. A section describing the main parameters you will set follows the block.
</p>

<pre class="rs_skip" style="overflow: auto"><code>

&lt;div id=&quot;[arbitrary unique ID]&quot; class=&quot;rs_skip&quot;&gt;
&lt;a href=&quot;http://app.readspeaker.com/cgi-bin/rsent?customerid=5204&amp;amp;lang=en_us&amp;amp;speed=[speed for downloaded file, from 0 to 200, 140 recommended]&amp;amp;readid=[ID of element you want read]&amp;amp;url=[full URL of page]&amp;amp;audiofilename=[file name for downloadable MP3 (optional)]&quot; 
  target=&quot;_blank&quot;  
  onclick=&quot;readpage(this.href, '[ID of element where you want player controls to display]'); return false;&quot;&gt;
&lt;img 
  style=&quot;border-style: none&quot; 
  src=&quot;img/listen-en-us-icon.gif&quot; 
  alt=&quot;Listen to this section&quot; 
  title=&quot;Listen to this section&quot; /&gt;&lt;a&gt;
&lt;div&gt;
&lt;div id=&quot;[ID of element where you want player controls to display]&quot;&gt;&lt;/div&gt; 

&lt;div id=&quot;[ID of element you want read (container for your content)]&quot;&gt;
[Your content goes here.]
&lt;/div&gt;

</code></pre>

<p>
<strong>Important parameters in query string:</strong>
</p>
<ul>
  <li><code>customerid</code> &#8212; The OSU customer ID must be part of each request. It is <em>5204</em></li>
  <li><code>speed</code> &#8212; Rate at which the MP3 download of the page is read. Can be any number between 0 and 200. We recommend 140 as a fast, yet understandable playback speed.</li>
  <li><code>readid</code> &#8212; The ID of the element you want read by ReadSpeaker. Element ID must be unique.</li>
  <li><code>url</code> &#8212; The full URL to the current page, e.g. <code>http://osu.edu/resources/my-page.html</code>.</li>
  <li><code>audiofilename</code> &#8212; File name for the MP3 of the content associated with the Listen link. This parameter is optional. If you do not include it, ReadSpeaker assigns the MP3 an arbitrary file name. You should have no spaces in your file name &#8212; use hypens or underscores to separate words.</li>
</ul>

<p>
You can have multiple Listen links on your page. Only make sure that <code>readid</code> parameter in the query string matches the section you want read and that this ID is unique on the page. 
</p>


<h3>Content Management System Plug-ins</h3>

<p>
<a href="http://plugins.voice-corp.com/?p=exp_hl">ReadSpeaker content management system plug-ins</a> are available for commonly-used CMS's, including WordPress, Drupal, and Joomla.
</p>

<h3>Placement and Appearance of ReadSpeaker Listen Link</h3>

<p>
VoiceCorp maintains a page with a large variety of <a href="https://media.readspeaker.com/images/buttons/index_en_us.php">ReadSpeaker Listen link images</a>. Of course,  you are welcome to customize one for your own web site, as well. It is also possible to start ReadSpeaker from a simple HTML link. We recommend using an image link, however, since it makes the functionality more obvious.
</p>

<p>
The Listen link should be close to the content and top-level heading of the page, so that there is an immediate mental link between the content and the Listen link.  From user observation conducted by VoiceCorp, the best place for the Listen link is just above the page content heading, aligned to the left. An alternative is to place it to the right of the main content heading.</p>

<p>If you have &#8220;print&#8221;, &#8220;share&#8221;, or other utility links at the top of page main content, group the Listen link with these.
</p>

<p>
If you have a page that has multiple discrete &#8220;chunks&#8221; of content within the main content area, such as is commonly seen on blog home pages, we recommend having a listen button for each chunk or item.
</p>

<p>
<span style="font-weight: bold; color: red">Important!</span> Make sure that the <code>DIV</code> for the ReadSpeaker controls is outside of the block you want read. If the controls are instantiated within the read block you will get unpredictable results when the Listen link is clicked.
</p>

<h3>Controlling Read Area</h3>

<p>ReadSpeaker will read and highlight all content within the element specified by the <code>readid</code> parameter in the query string of the call. (See source code for example.) However, you have finer-grained control within the element being read: Because we precede the following paragraph with a HTML comment of <code>RSPEAK_STOP</code> it does not get read.</p>

<!-- RSPEAK_STOP -->
<p>
This paragraph doesn't get read!
</p>
<!-- RSPEAK_START-->

<p>
Speaking begins again here because it has been turned back on with a <code>RSPEAK_START</code> comment.
</p>

<p>
Assigning a class of <code>rs_skip</code> to an element also causes ReadSpeaker to ignore it. Here is an example:
</p>

<p class="rs_skip">
ReadSpeaker ignores me!
</p>

<p>
You can include more than one listen button on a page if you want more control.
</p>

<h3>Pronunciation and the &#8220;Paul&#8221; Voice</h3>

<p>
The OSU implementation of ReadSpeaker does not recognize in-page language changes. So, though marked up correctly using the HTML <code>lang</code> attribute, <span lang="fr">qu'est-ce que c'est</span> does not get read with French pronunciation. Also, currently the OSU license is for English reading only. So foreign language sites will be read with incorrect pronunciation. The Steering Committee may explore extending the set of available languages.
</p>

<p>
Developers can request corrections to ReadSpeaker's pronunciation of OSU-specific terms and vocabulary. Pronunciation tweaking must be done by VoiceCorp. The Steering Committee will work out a protocol for requesting pronunciation corrections. In the meantime, you may send pronunciation correction requests to Ken Petri (<a href="mailto:petri.1@osu.edu?subject=ReadSpeaker pronunciation request">petri.1@osu.edu</a>).
</p>

<p>
For our first correction, we requested that the name Gordon Gee be pronounced properly. The training can differentiate between basic usages: The name Gordon Gee is pronounced differently than the phrase golly gee.
</p>

<p>
The &#8220;Paul&#8221; voice, which is the one OSU has purchased, pronounces many American English terms correctly. For example, it reads iTunes and U.S. properly.
</p>

<h3>Reading of PDF</h3>

<p>
Only text-based PDF's are voiced by ReadSpeaker. The PDF does not have to be tagged PDF. It only need be text-based. But an image-based PDF will return no audio content.
</p>

<p>
Because only one ReadSpeaker player instance can be running in a ReadSpeaker block at any one time, we advise linking to ReadSpeaker-generated MP3's of PDF's outside of the main ReadSpeaker block or ending the block before the PDF link and starting a new block (with a new Listen Button) after the PDF links. 
</p>

<p>
Immediately below this paragraph is a link to a sample PDF followed by a link to a ReadSpeaker-generated MP3. To have this work properly, make sure the Listen button at the top of this page is not active/expanded.
</p>

<p>
<a href="<?php echo getAddress(); ?>dump/readspeaker/media/sample.pdf">Title of My PDF (pdf)</a>
<span>
<a href="http://app.readspeaker.com/cgi-bin/rsent?customerid=5204&amp;lang=en_us&amp;speed=140&amp;url=<?php echo getAddress(); ?>/dump/readspeaker/media/sample.pdf&amp;save=1&amp;audiofilename=title-of-my-pdf">
<img 
  style="border-style: none" 
  src="img/listen-pdf-icon.png" 
  alt="Download MP3 of Title of My PDF" 
  title="Download MP3 of Title of My PDF" /></a>
</span>
</p>

<p>Note: For PDF files, embedded image alternative text is not spoken.</p>

<p>
Here is a sample code block for inserting the PDF and MP3 download link:
</p>

<pre style="overflow: auto;"><code>

&lt;a href=&quot;[PATH TO PDF FILE]&quot;&gt;Title of My PDF (pdf)&lt;/a&gt;
&lt;span&gt; 
&lt;a href=&quot;http://app.readspeaker.com/cgi-bin/rsent?customerid=5204&amp;amp;lang=en_us&amp;amp;speed=140&amp;amp;save=1&amp;amp;audiofilename=[DESIRED FILENAME FOR MP3 OF PDF DOWNLOAD]&amp;amp;url=[FULL URL TO PDF FILE]&gt;
&lt;img 
  style=&quot;border-style: none&quot; 
  src=&quot;img/listen-pdf-icon.png&quot; 
  alt=&quot;Download MP3 of Title of My PDF&quot; 
  title=&quot;Download MP3 of Title of My PDF&quot; /&gt;&lt;/a&gt;
&lt;/span&gt;

</code></pre>

<h3>Known Issues</h3>

<p>
In testing we have discovered a couple of problems you may encounter.
</p>

<p>The first problem is mentioned above in the discussion of PDF:</p>

<p>
You cannot have two instances of ReadSpeaker running within a single ReadSpeaker block. If you embed a call to ReadSpeaker within a block of HTML that is already designated to be read, either the embedded block will fail to play back or you will get unpredictable page display problems.
</p>

<p>
A second problem relates to Flash movies or applications embedded in your page:
</p>

<p>
ReadSpeaker uses a Flash-based streaming audio player to voice web pages. The ReadSpeaker player does not always &#8220;play nice&#8221; with other Flash movies embedded in the web page. For example, you will notice that the simple Flash button below appears to re-load after ReadSpeaker finishes reading this section of the page.
</p>

<p>To work around this problem, we advise that you end the area spoken by ReadSpeaker before or begin the ReadSpeaker area after any Flash movies or links to ReadSpeaker-generated PDF MP3s.</p>

<p>
<embed src="media/anibut.swf" style="width: 150px; height: 50px" type="application/x-shockwave-flash"></embed>
</p>
<p>
<i>(The Flash button above was copied from <a href="http://www.webdevelopersnotes.com/tutorials/adflash/flash_button_tutorial_animated_button.php3">Web Developer Notes' Flash Button Tutorial</a>.)</i>
</p>

<h2>Some Examples of How ReadSpeaker Voices HTML</h2>

<p>Below are some basic HTML elements so that you can hear and see how they are voiced and highlighted by ReadSpeaker.</p>

<h3>A Heading Level 3</h3>

<p>
Some content in a paragraph.
</p>

<ul>
	<li>Some content in an unordered list</li>
  <li>Item two</li>
  <li>Item three</li>
</ul>

<ol>
	<li>Some content in an ordered list</li>
  <li>Item two</li>
  <li>Item three</li>
</ol>

<h3>Some Information in a Table, with a Caption</h3>

<p>The caption is read aloud, as are all of the table headers and data. The table has a summary attribute, which is not read.</p>

<table border="1" summary="Two column table with top row being the headers for the columns">
<caption>Caption for the Table</caption>
<tr>
  <th scope="col">Table Header Column One</th>
  <th scope="col">Table Header Column Two</th>
</tr>
<tr>
	<td>Row 2 Column 1</td>
	<td>Row 2 Column 2</td>
</tr>
<tr>
	<td>Row 3 Column 1</td>
	<td>Row 3 Column 2</td>
</tr>
</table>

<h3>Abbreviations</h3>

<p>
The value of the title attribute of abbreviation (ABBR) tags is spoken. For example, <abbr title="World Wide Web Consortium">W3C</abbr> is read as World Wide Web Consortium.
</p>

<h3>An Image with Alternative Text</h3>

<p>The image below has alternative text associated with it. ReadSpeaker speaks the alternative text:</p>

<p>
<img src="img/invisible-visible-cat-bike.jpg" alt="Side-by-side pictures of a cat jumping, with a BMX bike superimposed underneath the cat picture on the right-hand side. Large text on left side picture reads Invisible Bike. Picture on right reads Visible Bike." />
<br/><i><b>Figure:</b> Invisible bike, visible bike images from <a href="http://icanhascheezburger.com/">I can haz cheez burger</a>.</i>
</p>

</div><!-- end ReadSpeaker spoken div -->

</div>
</body>
</html>
